/***************************************************************************
                          ezconfig  -  description
                             -------------------
    begin                : Dec. 26, 2004
    copyright            : (C) 2005 by Allen
    email                : bon_ami_@hotmail.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   Explicit Distribution Limitation                                      *
 *   This rule overrides others below.                                     *
 *   This program may not be modified or used by, or, if possible,         *
 *   redistributed to people described as below,                           *
 *   1.Japanese who hold hostility against Chinese.                        *
 *   2.or, those who discriminate against people based solely on race,     *
 *     gender or sexual orientation.                                       *
 *                                                                         *
 ***************************************************************************/
/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
/*
 *	Configuration client sample code file
 */

#include <iostream>

#include "ezconfig.h"

using namespace ezproject;
using std::cout;
using std::cin;
using std::endl;

erttp clntsmpl(ezconfig &z)
{
	vector<ezconfig::vctrdpttp> vctrs;
	ezconfig::vctrlvltp lvls = 2;
	ezconfig::vctrmnttp son;
	ezconfig::vctrdpttp dpt;
	vector<ezconfig::vctrmnttp> olds;
	vector<ezconfig::vctrdpttp> vctrscln;
	erttp ret;
	unsigned char i = 0;
	int goti = 77;
	char gotc = 's';
	string s;

	do
	{
		switch (++i)
		{
			case 1:
				ret = z.regele<int>(vctrs, lvls);
				cout << "reg ancestor ele";
				break;
			case 2:
				ret = z.nmele(vctrs, "ancestor", s);
				cout << "name ancestor ele";
				break;
			case 3:
				ret = z.setele(vctrs, lvls = 1, goti);
				cout << "set ancestor ele";
				break;
			case 4:
				ret = z.getele(vctrs, lvls = 2, goti, s);
				cout << "get ancestor ele";
				break;
			case 5:
			case 9:
			case 10:
			case 11:
			case 12:
			case 13:
				switch (i)
				{
					case 5:
						s.assign("son");
						break;
					case 9:
						vctrs.clear();
						s.assign("elder brother");
						break;
					case 10:
						dpt.first = son;
						vctrs.assign(1, dpt);
						vctrscln = vctrs;
						s.assign("baby");
						break;
					case 11:
						vctrscln = vctrs;
						s.assign("baby");
						break;
					case 12:
						vctrs.clear();
						s.assign("younger brother");
						break;
					case 13:
						s.clear();
						break;
				}
				if (s.empty())
					ret = z.regq(vctrs, son);
				else
				{
					if (vctrscln.size() > 0)
						ret = z.regq(vctrscln, son, s);
					else
						ret = z.regq(vctrs, son, s);
				}
				cout << "reg q";
				break;
			case 6:
				dpt.first = son;
				vctrs.assign(1, dpt);
				vctrscln = vctrs;
				ret = z.regele<char>(vctrscln, lvls = 4);
				cout << "reg son ele";
				break;
			case 7:
				vctrscln = vctrs;
				ret = z.setele(vctrscln, lvls = 2, gotc);
				cout << "set son ele";
				break;
			case 8:
				vctrscln = vctrs;
				ret = z.getele(vctrscln, lvls = 3, gotc, s);
				cout << "get son ele";
				break;
			case 20:
				i = 0;
			case 14:
			case 18:
			case 19:
				ret = z.wlk(vctrs, dpt);
				cout << "walk through";
				break;
			case 15:
			case 16:
				switch (i)
				{
					case 15:
						vctrs.assign(1, dpt);
						break;
					case 16:
						dpt = std::make_pair(0, "younger brother");
						vctrs.assign(1, dpt);
						break;
				}
				ret = z.unregele<char>(vctrs, dpt);
				cout << "unreg q";
				break;
			case 17:
				ret = z.sqz(vctrscln, olds, vctrs);
				cout << "sqeeze";
				break;
		}
		cout << "[step:" << static_cast<int>(i) << ']';
		switch (ret)
		{
			case RTTP_CRER:
				cout << " : Critical Error!" << endl;
				break;
			case RTTP_MNER:
				cout << " : Minor Error!" << endl;
				break;
			case RTTP_NOER:
				switch (i)
				{
					case 14:
					case 18:
						cout << " : no error" << "\tson information: "
							<< static_cast<int>(dpt.first) << " ; " << dpt.second << endl;
						break;
					default:
						cout << " : no error" << endl;
				}
				break;
			case RTTP_RGHT:
				cout << " : right\t";
				switch (i)
				{
					case 1:
						cout << "level count: " << static_cast<int>(lvls);
						break;
					case 2:
						cout << "old name: " << s;
						break;
					case 3:
						cout << "value set: " << goti << " @ " << static_cast<int>(lvls);
						break;
					case 4:
						cout << "item: " << s << " = " << goti << " @ "
							<< static_cast<int>(lvls);
						break;
					case 5:
					case 9:
					case 10:
					case 11:
					case 12:
					case 13:
						cout << "\tson born: " << s << " @ " << static_cast<int>(son);
						break;
					case 6:
						cout << "son has: " << static_cast<int>(lvls) << " levels";
						break;
					case 7:
						cout << "son set: " << gotc << " @ " << static_cast<int>(lvls);
						break;
					case 8:
						cout << "son get: " << s << " = " << gotc << " @ "
							<< static_cast<int>(lvls);
						break;
					case 14:
					case 15:
					case 16:
					case 18:
					case 19:
					case 0:
						cout << "\tson information: " << static_cast<int>(dpt.first)
							<< " ; " << dpt.second;
						break;
					case 17:
						cout << "\tsons alive: ";
						for (vector<ezconfig::vctrdpttp>::const_iterator it
							= vctrscln.begin(); it != vctrscln.end(); it++)
						{
							cout << static_cast<int>(it->first)
								<< " ; " << it->second << '\t';
						}
						break;
				}
				cout << endl;
				break;
			case RTTP_NA:
				cout << " : N/A!" << endl;
				break;
		}
		if (ret < RTTP_NOER)
			i = 0;
	} while (i != 0);

	cout << endl << "destructions\t" << std::flush;
	vctrs.clear();
	ret = RTTP_RGHT;
	dpt.second.clear();
	do
	{
		cout << " ." << std::flush;
		vctrscln = vctrs;
		if (z.wlk(vctrscln, dpt) >= RTTP_NOER)
		{
			cout << static_cast<int>(dpt.first) << ':' << dpt.second;
			vctrs.insert(vctrs.begin(), dpt);
			cout << "{depth=" << vctrs.size() << '}';
		}
		else
		{
			vctrscln = vctrs;
			if (dpt.second.compare("son"))
				ret = z.unregele<char>(vctrscln, dpt);
			else
				ret = z.unregele<int>(vctrscln, dpt);
			cout << static_cast<int>(dpt.first) << ':' << dpt.second
				<< " died";
			if (vctrs.size() > 0)
			{
				vctrs.erase(vctrs.begin());
				cout << "{depth=" << vctrs.size() << '}';
			}
			switch (ret)
			{
				case RTTP_CRER:
					cout << "(X!)";
					break;
				case RTTP_MNER:
					cout << "(X)";
					break;
				case RTTP_NOER:
					cout << "(-)";
					break;
				case RTTP_RGHT:
					cout << "(O)";
					break;
				case RTTP_NA:
					cout << "(?)";
					break;
			}
		}
	} while (ret != RTTP_NOER);

	return ret;
}

bool itmhndl(string sctn, string itmnm, string itmvl)
{
	cout << "We've read item [" << itmnm << "] valued as [" << itmvl
		<< "] in section [" << sctn << "]" << endl;
	if ((0 == sctn.compare("last")) && (0 == itmnm.compare("end")))
		return false;
	return true;
}

bool hlphndl(string &flnm)
{
	static unsigned char i = 0;

	switch (i++)
	{
		case 0:
			cout << "If you haven't created sample.cf in this directory, "
				"which should be the case, you'll surely come to this point.  "
				"Now please check the correction flow by entering a wrong file "
				"name again, which should refer to a file not existed yet or "
				"you have no priviledge to read. If you are not sure what "
				"I'm saying here, just Enter exactly as below." << endl
				<< "sample.c" << endl;
			break;
		default:
			cout << "Now please Enter our file name (10 letters and then [Enter]) "
				"exactly as below to continue.  If you wanna test the flow "
				"again, just repeat last step." << endl << "sample.cfg" << endl;
	}
	cin >> flnm;

	return true;
}

int main(int argc, char *argv[])
{
	ezconfig z;
	char gn;
	ezcnfgclnt zc;
	string fn("sample.cf");
	string errmsg;

	clntsmpl(z);
	cout << "\nConfig Server demonstration ended. Please press any letter and "
		"[Enter] to go on to client demonstration: " << std::flush;

	cin >> gn;
	zc.regitm(itmhndl);
	zc.reghlp(hlphndl);
	switch (zc.run(fn, errmsg))
	{
		case RTTP_RGHT:
			cout << "It seems all right." << endl;
			break;
		case RTTP_NOER:
			cout << "Exit as requested. To test normal ending, "
				"remove/modify the 'end' item name in 'last' "
				"section in config file." << endl;
			break;
		case RTTP_MNER:
			cout << "File(s) failed to be opened anyway." << endl;
			break;
		case RTTP_CRER:
			cout << "Interface lack. (should not be the case)"
				<< endl;
			break;
		case RTTP_NA:
			cout << "No configurations read." << endl;
			break;
	}
	cout << "Message from Client: " << errmsg << endl;

	return 0;
}

